#include"p30f2011.h"
#include "main.h"
#include "L3G4200D.h"

void GyroInit()
{
	__delay_ms(150);	//Wait for gyro wake up

	// Enable x, y, z and turn off power down:
	writeRegister(L3G4200D_ADRESS, L3G_CTRL_REG1, 0b00001111);

	// If you'd like to adjust/use the HPF, you can edit the line below to configure CTRL_REG2:
	writeRegister(L3G4200D_ADRESS, L3G_CTRL_REG2, 0b00000000);
	
	// Configure CTRL_REG3 to generate data ready interrupt on INT2
	// No interrupts used on INT1
	writeRegister(L3G4200D_ADRESS, L3G_CTRL_REG3, 0b00001000);
	
	// CTRL_REG4 250dps, 100Hz:	
	writeRegister(L3G4200D_ADRESS, L3G_CTRL_REG4, 0b00000000);
		
	// CTRL_REG5 controls high-pass filtering of outputs, use it
	// if you'd like:
	writeRegister(L3G4200D_ADRESS, L3G_CTRL_REG5, 0b00000000);
}

void writeRegister(unsigned char deviceAddress, unsigned char address, unsigned char val)
{
    I2CStart(deviceAddress); 
	I2CSend(address);   
	I2CSend(val);   
	I2CStop();     
}

unsigned char readRegister(unsigned char deviceAddress, unsigned char address)
{
    I2CStart(deviceAddress); 	
	I2CSend(address);
	I2CReStart(deviceAddress | 0b00000001);	//When read gyro sens, set BIT0 !
	I2CCONbits.RCEN = 1;
	I2CWait();
	I2CCONbits.ACKDT = 1;	//Send NACK
	I2CCONbits.ACKEN = 1;
	I2CCONbits.ACKDT = 0;
	I2CWait();
	I2CStop();
    return I2CRCV;
}

void ReadData(int *Data)
{
	unsigned char Temp[6];
    I2CStart(L3G4200D_ADRESS); 	
	I2CSend(L3G_OUT_X_L | 0b10000000);	//Multiple read, set BIT7
	I2CReStart(L3G4200D_ADRESS | 0b00000001);
	I2CCONbits.RCEN = 1;
	I2CWait();
	Temp[0] = I2CRCV;
	I2CCONbits.ACKDT = 0;	//Send ACK
	I2CCONbits.ACKEN = 1;
	I2CWait();
	I2CCONbits.RCEN = 1;
	I2CWait();
	Temp[1] = I2CRCV;
	I2CCONbits.ACKEN = 1;
	I2CWait();
	I2CCONbits.RCEN = 1;
	I2CWait();
	Temp[2] = I2CRCV;
	I2CCONbits.ACKEN = 1;
	I2CWait();
	I2CCONbits.RCEN = 1;
	I2CWait();
	Temp[3] = I2CRCV;
	I2CCONbits.ACKEN = 1;
	I2CWait();
	I2CCONbits.RCEN = 1;
	I2CWait();
	Temp[4] = I2CRCV;
	I2CCONbits.ACKEN = 1;
	I2CWait();
	I2CCONbits.RCEN = 1;
	I2CWait();
	Temp[5] = I2CRCV;
	I2CCONbits.ACKDT = 1;	//Send NACK
	I2CCONbits.ACKEN = 1;
	I2CWait();
	I2CStop();


	*Data = Temp[1];
	*Data = *Data << 8;
	*Data = *Data | Temp[0];
	Data++;
	*Data = Temp[3];
	*Data = *Data << 8;
	*Data = *Data | Temp[2];
	Data++;		
	*Data = Temp[5];
	*Data = *Data << 8;
	*Data = *Data | Temp[4];
}
