
//LCD Connection pins
#define E LATCbits.LATC14
#define R_W LATBbits.LATB6
#define RS LATCbits.LATC13
#define LCD_DATA_PIN LATB
#define LCDMASK 0b00001111

#define     FALSE       0
#define     TRUE        1


//LCD Commands

#define     CLR_DISP        0b00000001 //Clear display

#define     CUR_HOME        0b00000010    //Move cursor home and clear screen memory
#define     CUR_RIGHT       0b00010100    //Move cursor one to right
#define     CUR_LEFT        0b00010000    //Move cursor one to left

#define     SCROLL_RIGHT    0b00011100    //Scroll entire screen right one space
#define     SCROLL_LEFT     0b00011000    //Scroll entire screen left one space

#define     DISP_ON         0b00001100    //Turn visible LCD on
#define     DISP_OFF        0b00001000    //Turn visible LCD off

#define     UNDERLINE_ON    0b00001110    //Turn on underlined cursor
#define     UNDERLINE_OFF   0b00001100    //Turn off underlined cursor

#define     BLINKCUR_ON     0b00001101    //Turn on blinking box cursor
#define     BLINKCUR_OFF    0b00001100    //Turn off blinking box cursor

#define     DUALCUR_ON      0b00001111    //Turn on blinking box and underline cursor
#define     DUALCUR_OFF     0b00001100    //Turn off blinking box and underine cursor

#define     SET_CURSOR      0b10000000    //SET_CURSOR + X : Sets cursor position to X

#define     ENTRY_INC       0b00000110 //
#define     DD_RAM_ADDR     0b10000000 //
#define     DD_RAM_ADDR2    0b11000000 //
#define     CG_RAM_ADDR     0b01000000 //

//Functions

void LCDInit();
void LCDSendCommand(unsigned char Cmd);
void LCDSendString(char *ptr);
void LCDSendChar(unsigned char *chr);
void LCDSetCGRAM(unsigned char Address, unsigned char *ptr);
void IntToChar(int number, char *chr);	//Convert integer to charater array
